'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const JSAsset = require('./JSAsset');
const localRequire = require('../utils/localRequire');

class CoffeeScriptAsset extends JSAsset {

  install() {
    var _this = this;

    return _asyncToGenerator(function* () {
      return [...(yield JSAsset.prototype.install.call(_this)), { name: 'coffeescript', dev: true }];
    })();
  }

  parse(code) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      // require coffeescript, installed locally in the app
      let coffee = yield localRequire('coffeescript', _this2.name);

      // Transpile Module using CoffeeScript and parse result as ast format through babylon
      let transpiled = coffee.compile(code, {
        sourceMap: _this2.options.sourceMaps
      });

      if (transpiled.sourceMap) {
        _this2.sourceMap = transpiled.sourceMap.generate();
        _this2.sourceMap.sources = [_this2.relativeName];
        _this2.sourceMap.sourcesContent = [_this2.contents];
      }

      _this2.contents = _this2.options.sourceMaps ? transpiled.js : transpiled;
      return yield JSAsset.prototype.parse.call(_this2, _this2.contents);
    })();
  }
}

module.exports = CoffeeScriptAsset;