'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const dbg = require('debug')('parcel:VueAsset');
const JSAsset = require('./JSAsset');
const compiler = require('../transforms/vue');

class VueAsset extends JSAsset {
  install() {
    return _asyncToGenerator(function* () {
      return [{ name: 'vue', dev: false }, { name: 'vuex', dev: false }, { name: 'vue-router', dev: false }, { name: 'vuex-router-sync', dev: false },
      // {name: 'vue-hot-reload-api', dev: false},
      { name: 'vue-template-compiler', dev: false }, {
        name: 'vue-component-compiler@https://github.com/shawwn/vue-component-compiler#parcel-vue-component-compiler',
        dev: false
      }];
    })();
  }

  parse(code) {
    var _this = this;

    return _asyncToGenerator(function* () {
      dbg('parse', code);
      // let vueconfig = await config.load(this.name, ['vue.config.json']);
      _this.vue = compiler(code, _this.name);
      dbg('parse:vue', code);
      _this.contents = _this.vue.code;
      _this.vue.dependencies.forEach(function (v, k) {
        const contents = v.code;
        dbg('parse:vue:write', [k, contents]);
        _this.addDependency(k, { contents: contents });
      });
      return yield JSAsset.prototype.parse.call(_this, _this.contents);
    })();
  }
}

module.exports = VueAsset;